import { LRParser } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Identifier = {__proto__:null,avg:69, cdf:71, log10:73, corr:75, hist:77, max:79, mean:81, min:83, ln:87, regress:89, shift:91, sqrt:93, stdev:95, sum:97};
const parser = LRParser.deserialize({
  version: 13,
  states: "&xOVQPOOOOQO'#Cj'#CjOOQO'#Ca'#CaO!dQPO'#C`OOQO'#Cr'#CrQ!iQPOOOOQO'#Cy'#CyOVQPO'#CxOOQO'#C^'#C^OOQO'#Cb'#CbOOQO'#Cc'#CcOOQO'#Cd'#CdOOQO'#Ce'#CeOOQO'#Cf'#CfOOQO'#Cg'#CgOOQO'#Ch'#ChOOQO'#Ci'#CiOOQO'#Ck'#CkOOQO'#Cl'#ClOOQO'#Cm'#CmOOQO'#Cn'#CnOOQO'#Co'#CoOOQO'#Cp'#CpO!zQPO'#CqOOQO,58z,58zOOQO'#Ct'#CtOOQO'#Cu'#CuOOQO'#Cv'#CvOOQO'#Cw'#CwOVQPO,59_OVQPO,59_OVQPO,59_OVQPO,59_O#RQPO,59dO#mQPO'#DaO#wQPO,59]O$eQPO1G.yO%TQPO1G.yO%[QPO1G.yO%cQPO1G.yOVQPO'#CzO%jQPO,59{OOQO1G.w1G.wO%rQPO,59fOOQO-E6x-E6x",
  stateData: "%|~OqOS~ORWOrXOsYOtZOu[Ov]Ow^Ox_Oy`OzPO{aO|bO}cO!OdO!PeO!QfO!VSO!XUO!YUO~O!SgO~OzPO!WiO!XjO!YkO!ZlO~O!R!TP~PVO!WiOolazla!Xla!Yla!Zla!Rla!Ula~O!UxO!R!TX~P!iO!RzO~O!WiOogi!Xgi!Ygi!Zgi!Rgi!Ugi~Ozgi~P#|OzPO!WiO!ZlOogi!Ygi!Rgi!Ugi~O!Xgi~P$lO!XjO~P$lOzPO~P#|O!UxO!R!Ta~O!Rna!Una~P!iO",
  goto: "$u!UPP!VP!o!y#T#T#T#T#T#T#T#T#_#T#T#T#T#T#T#q!o!o#t$O$U$Z!o$b$lPPPPPPPPPPPPPPPPPPPP$rQTOQqVQrgQtmQunQvoQwpR{xaWOVgmnopxaROVgmnopxaQOVgmnopx`QOVgmnopx]mTruvw{RhRamTqrtuvw{XnTrv{VoTr{ZpTruv{aVOVgmnopxQyrR|yRsg",
  nodeNames: "⚠ BSLang Expr Identifier FunctionCall FunctionIdentifier Average Cdf CommonLog Correlation Histogram Maximum Mean Minimum Mul NaturalLog Regression Shift Sqrt StandardDeviation Sum FunctionCallBody NumberLiteral BinaryExpression Pow Add Sub Div UnaryExpression UnaryOp",
  maxTerm: 57,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "%h~R`XY!TYZ!T]^!Tpq!Txy!fyz!kz{!p{|!u|}!z}!O#P!O!P#U!P!Q$U!Q![$Z!c!}$l#Q#R%c#T#o$l~!YSq~XY!TYZ!T]^!Tpq!T~!kO!S~~!pO!R~~!uOz~~!zO!X~~#PO!U~~#UO!Y~~#XP!Q![#[~#aR!V~!Q![#[!g!h#j#X#Y#j~#mR{|#v}!O#v!Q![#|~#yP!Q![#|~$RP!V~!Q![#|~$ZO!Z~~$`S!V~!O!P#[!Q![$Z!g!h#j#X#Y#j~$qSR~!O!P$}!Q![%W!c!}$l#T#o$l~%QQ!c!}$l#T#o$l~%]QR~!O!P$}!Q![%W~%hO!W~",
  tokenizers: [0],
  topRules: {"BSLang":[0,1]},
  specialized: [{term: 3, get: value => spec_Identifier[value] || -1}],
  tokenPrec: 0
});

const BSLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ['('] }
    }
});
const bslangCompletion = (sources) => {
    return BSLanguage.data.of({
        autocomplete: completeFromList([
            { label: "avg", type: "function" },
            { label: "cdf", type: "function" },
            { label: "log10", type: "function" },
            { label: "corr", type: "function" },
            { label: "hist", type: "function" },
            { label: "max", type: "function" },
            { label: "mean", type: "function" },
            { label: "min", type: "function" },
            { label: "ln", type: "function" },
            { label: "regress", type: "function" },
            { label: "shift", type: "function" },
            { label: "sqrt", type: "function" },
            { label: "stdev", type: "function" },
            { label: "sum", type: "function" },
        ].concat(sources))
    });
};
function BSLANG(autocompletionSources = []) {
    return new LanguageSupport(BSLanguage, [bslangCompletion(autocompletionSources)]);
}

// This file was generated by lezer-generator. You probably shouldn't edit it.
const
  BSLang = 1,
  Expr = 2,
  Identifier = 3,
  FunctionCall = 4,
  FunctionIdentifier = 5,
  Average = 6,
  Cdf = 7,
  CommonLog = 8,
  Correlation = 9,
  Histogram = 10,
  Maximum = 11,
  Mean = 12,
  Minimum = 13,
  Mul = 14,
  NaturalLog = 15,
  Regression = 16,
  Shift = 17,
  Sqrt = 18,
  StandardDeviation = 19,
  Sum = 20,
  FunctionCallBody = 21,
  NumberLiteral = 22,
  BinaryExpression = 23,
  Pow = 24,
  Add = 25,
  Sub = 26,
  Div = 27,
  UnaryExpression = 28,
  UnaryOp = 29;

var parser_terms = /*#__PURE__*/Object.freeze({
  __proto__: null,
  BSLang: BSLang,
  Expr: Expr,
  Identifier: Identifier,
  FunctionCall: FunctionCall,
  FunctionIdentifier: FunctionIdentifier,
  Average: Average,
  Cdf: Cdf,
  CommonLog: CommonLog,
  Correlation: Correlation,
  Histogram: Histogram,
  Maximum: Maximum,
  Mean: Mean,
  Minimum: Minimum,
  Mul: Mul,
  NaturalLog: NaturalLog,
  Regression: Regression,
  Shift: Shift,
  Sqrt: Sqrt,
  StandardDeviation: StandardDeviation,
  Sum: Sum,
  FunctionCallBody: FunctionCallBody,
  NumberLiteral: NumberLiteral,
  BinaryExpression: BinaryExpression,
  Pow: Pow,
  Add: Add,
  Sub: Sub,
  Div: Div,
  UnaryExpression: UnaryExpression,
  UnaryOp: UnaryOp
});

export { BSLANG, BSLanguage, parser_terms as Terms, bslangCompletion };
